﻿' ----- The Library Project
'       Start-to-Finish Visual Basic 2015
'       Copyright (c) 2015 by Tim Patrick

Public Class AboutProgram
    Private Sub CompanyWeb_LinkClicked(sender As Object,
             e As LinkLabelLinkClickedEventArgs) Handles CompanyWeb.LinkClicked
        ' ----- Show the company web page.
        Process.Start("http://www.owanipress.com")
    End Sub

    Private Sub CompanyEmail_LinkClicked(sender As Object,
            e As LinkLabelLinkClickedEventArgs) Handles CompanyEmail.LinkClicked
        ' ----- Send email to the company.
        Process.Start("mailto:tim@timaki.com")
    End Sub

    Private Sub AboutProgram_Load(sender As Object, e As EventArgs) Handles Me.Load
        ' ***** Insert Code Snippet #6 here.

        ' ----- Update the version number.
        ProgramVersion.Text = String.Format("Version {0}.{1} Revision {2}",
            My.Application.Info.Version.Major,
            My.Application.Info.Version.Minor,
            My.Application.Info.Version.Revision)

        ' ----- Prepare the form for later fade-out.
        Me.Opacity = 0.99
    End Sub

    Private Sub ActClose_Click(sender As Object, e As EventArgs) Handles ActClose.Click
        ' ----- Fade the form out.
        For counter As Integer = 90 To 10 Step -20
            Me.Opacity = counter / 100
            Me.Refresh()
            Threading.Thread.Sleep(50)
        Next counter
        Me.DialogResult = DialogResult.Cancel
    End Sub
End Class