﻿' ----- The Library Project
'       Start-to-Finish Visual Basic 2015
'       Copyright (c) 2015 by Tim Patrick

Public Class MainForm
    ' ***** Insert Code Snippet #8 here.

    Private Sub ActHelpAbout_Click(sender As Object, e As EventArgs) Handles ActHelpAbout.Click
        ' ----- Show the About form.
        AboutProgram.ShowDialog()
    End Sub

    Private Sub ActLibraryItem_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActLibraryItem.LinkClicked
        ' ----- Library Item mode.
        TaskLibraryItem()
    End Sub

    Private Sub PicLibraryItem_Click(sender As Object, e As EventArgs) Handles PicLibraryItem.Click
        ' ----- Library Item mode.
        TaskLibraryItem()
    End Sub

    Private Sub ActPatronRecord_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActPatronRecord.LinkClicked
        ' ----- Patron Record mode.
        TaskPatronRecord()
    End Sub

    Private Sub PicPatronRecord_Click(sender As Object, e As EventArgs) Handles PicPatronRecord.Click
        ' ----- Patron Record mode.
        TaskPatronRecord()
    End Sub

    Private Sub ActHelp_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActHelp.LinkClicked
        ' ----- Help mode.
        TaskHelp()
    End Sub

    Private Sub PicHelp_Click(sender As Object, e As EventArgs) Handles PicHelp.Click
        ' ----- Help mode.
        TaskHelp()
    End Sub

    Private Sub ActCheckOut_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActCheckOut.LinkClicked
        ' ----- Check Out mode.
        TaskCheckOut()
    End Sub

    Private Sub PicCheckOut_Click(sender As Object, e As EventArgs) Handles PicCheckOut.Click
        ' ----- Check Out mode.
        TaskCheckOut()
    End Sub

    Private Sub ActCheckIn_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActCheckIn.LinkClicked
        ' ----- Check In mode.
        TaskCheckIn()
    End Sub

    Private Sub PicCheckIn_Click(sender As Object, e As EventArgs) Handles PicCheckIn.Click
        ' ----- Check In mode.
        TaskCheckIn()
    End Sub

    Private Sub ActAdmin_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActAdmin.LinkClicked
        ' ----- Administration mode.
        TaskAdmin()
    End Sub

    Private Sub PicAdmin_Click(sender As Object, e As EventArgs) Handles PicAdmin.Click
        ' ----- Administration mode.
        TaskAdmin()
    End Sub

    Private Sub ActProcess_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActProcess.LinkClicked
        ' ----- Daily Processing mode.
        TaskProcess()
    End Sub

    Private Sub PicProcess_Click(sender As Object, e As EventArgs) Handles PicProcess.Click
        ' ----- Daily Processing mode.
        TaskProcess()
    End Sub

    Private Sub ActReports_LinkClicked(sender As Object, e As LinkLabelLinkClickedEventArgs) Handles ActReports.LinkClicked
        ' ----- Print Reports mode.
        TaskReports()
    End Sub

    Private Sub PicReports_Click(sender As Object, e As EventArgs) Handles PicReports.Click
        ' ----- Print Reports mode.
        TaskReports()
    End Sub

    Private Sub TaskLibraryItem()
        ' ----- Library item task.

        ' ----- Update the display.
        AllPanelsInvisible()
        PanelLibraryItem.Visible = True
        ActLibraryItem.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicLibraryItem.Top)
        Me.AcceptButton = ActSearch

        ' ----- Get ready for a new search.
        If (SearchText.CanFocus) Then SearchText.Focus()
    End Sub

    Private Sub TaskPatronRecord()
        ' ----- Patron Record mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        PanelPatronRecord.Visible = True
        ActPatronRecord.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicPatronRecord.Top)
        Me.AcceptButton = ActAccessPatron
    End Sub

    Private Sub TaskHelp()
        ' ----- Help mode.

        ' ----- Update the display.
        AllPanelsInvisible()
        PanelHelp.Visible = True
        ActHelp.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicHelp.Top)
        Me.AcceptButton = Nothing
    End Sub

    Private Sub TaskCheckOut()
        ' ----- Check Out mode.

        ' ----- Update the display.
        AllPanelsInvisible()

        ' ***** Remove next source line, and then
        ' ***** Insert Code Snippet #15 here.
        PanelCheckOut.Visible = True

        ActCheckOut.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicCheckOut.Top)
        Me.AcceptButton = ActDoCheckOut
    End Sub

    Private Sub TaskCheckIn()
        ' ----- Check In mode.

        ' ----- Update the display.
        AllPanelsInvisible()

        ' ***** Remove next source line, and then
        ' ***** Insert Code Snippet #16 here.
        PanelCheckIn.Visible = True

        ActCheckIn.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicCheckIn.Top)
        Me.AcceptButton = ActDoCheckIn

        ' ----- Reset the input fields.
        CheckInDate.Value = Today
        CheckInDate.MaxDate = Today
        CheckInDate.MinDate = Today.AddDays(-6)
        CheckInDay.Text = "Today"
        CheckInDay.BackColor = SystemColors.Control
        CheckInDay.ForeColor = SystemColors.ControlText
        CheckInBarcode.Text = ""
        LabelCheckedIn.Visible = False
        CheckedInDetail.Visible = False
        CheckedInDetail.Text = "No information available."
        CheckInBarcode.Focus()
    End Sub

    Private Sub TaskAdmin()
        ' ----- Administration mode.

        ' ----- Update the display.
        AllPanelsInvisible()

        ' ***** Remove next source line, and then
        ' ***** Insert Code Snippet #17 here.
        PanelAdmin.Visible = True

        ActAdmin.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicAdmin.Top)
        Me.AcceptButton = Nothing
    End Sub

    Private Sub TaskProcess()
        ' ----- Daily Processing mode.

        ' ----- Update the display.
        AllPanelsInvisible()

        ' ***** Remove next source line, and then
        ' ***** Insert Code Snippet #18 here.
        PanelProcess.Visible = True

        ActProcess.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicProcess.Top)
        Me.AcceptButton = ActDoProcess
    End Sub

    Private Sub TaskReports()
        ' ----- Print Reports mode.

        ' ----- Update the display.
        AllPanelsInvisible()

        ' ***** Remove next source line, and then
        ' ***** Insert Code Snippet #14 here.
        PanelReports.Visible = True

        ActReports.BackColor = SystemColors.Control
        LabelSelected.Location = New Point(LabelSelected.Left, PicReports.Top)
        Me.AcceptButton = ActDoReports
    End Sub

    Private Sub MainForm_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' ----- Adjust the various panel positions.
        PanelLibraryItem.Location = New Point(
            TaskListBackground.Width, WelcomeBackground.Height)
        PanelPatronRecord.Location = PanelLibraryItem.Location
        PanelHelp.Location = PanelLibraryItem.Location
        PanelCheckOut.Location = PanelLibraryItem.Location
        PanelCheckIn.Location = PanelLibraryItem.Location
        PanelAdmin.Location = PanelLibraryItem.Location
        PanelProcess.Location = PanelLibraryItem.Location
        PanelReports.Location = PanelLibraryItem.Location
        PanelLibraryItem.Visible = True
        ActSearchLimits.PerformClick()

        ' ***** Insert Code Snippet #13 here.

    End Sub

    Private Sub AllPanelsInvisible()
        ' ----- Hide all work panels.
        PanelLibraryItem.Visible = False
        PanelPatronRecord.Visible = False
        PanelHelp.Visible = False
        PanelCheckOut.Visible = False
        PanelCheckIn.Visible = False
        PanelAdmin.Visible = False
        PanelProcess.Visible = False
        PanelReports.Visible = False

        ' ----- Correctly color all action labels.
        ActLibraryItem.BackColor = Color.White
        ActPatronRecord.BackColor = Color.White
        ActHelp.BackColor = Color.White
        ActCheckOut.BackColor = Color.White
        ActCheckIn.BackColor = Color.White
        ActAdmin.BackColor = Color.White
        ActProcess.BackColor = Color.White
        ActReports.BackColor = Color.White
    End Sub

    Private Sub SearchText_Enter(sender As Object, e As EventArgs) Handles SearchText.Enter
        ' ----- Highlight the entire text.
        SearchText.SelectAll()
    End Sub

    Private Sub ActSearchLimits_Click(sender As Object, e As EventArgs) Handles ActSearchLimits.Click
        ' ----- Toggle the display of the media type and location fields.
        If (ActSearchLimits.Top = LabelMoreLimitsTop.Top) Then
            ' ----- Hide the two fields.
            LabelSearchMediaType.Visible = False
            SearchMediaType.Visible = False
            LabelSearchLocation.Visible = False
            SearchLocation.Visible = False
            ActSearchClear.Location = New Point(ActSearchClear.Left,
                SearchMediaType.Top)
            ActSearchLimits.Location = New Point(ActSearchLimits.Left,
                SearchMediaType.Top)
            ActSearch.Location = New Point(ActSearch.Left, SearchMediaType.Top)
            ActSearchLimits.Text = "Mor&e >>"
        Else
            ' ----- Show the two fields.
            ActSearchClear.Location = New Point(ActSearchClear.Left,
                LabelMoreLimitsTop.Top)
            ActSearchLimits.Location = New Point(ActSearchLimits.Left,
                LabelMoreLimitsTop.Top)
            ActSearch.Location = New Point(ActSearch.Left, LabelMoreLimitsTop.Top)
            LabelSearchMediaType.Visible = True
            SearchMediaType.Visible = True
            LabelSearchLocation.Visible = True
            SearchLocation.Visible = True
            ActSearchLimits.Text = "<< L&ess"
        End If
    End Sub

    Private Sub CheckInBarcode_Enter(sender As Object, e As EventArgs) Handles CheckInBarcode.Enter
        ' ----- Highlight the entire text.
        CheckInBarcode.SelectAll()
    End Sub

    Private Sub CheckOutBarcode_Enter(sender As Object, e As EventArgs) Handles CheckOutBarcode.Enter
        ' ----- Highlight the entire text.
        CheckOutBarcode.SelectAll()
    End Sub

    Private Sub MainForm_KeyDown(sender As Object, e As KeyEventArgs) Handles MyBase.KeyDown
        ' ----- The keys F2 through F9 access the different sections of the form.
        Select Case (e.KeyCode)
            Case Keys.F2
                TaskLibraryItem()
                e.Handled = True
            Case Keys.F3
                TaskPatronRecord()
                e.Handled = True
            Case Keys.F4
                ' ----- Allow form to handle Alt+F4.
                If (e.Alt = True) Then
                    Me.Close()
                Else
                    TaskHelp()
                End If
                e.Handled = True
            Case Keys.F5
                TaskCheckOut()
                e.Handled = True
            Case Keys.F6
                TaskCheckIn()
                e.Handled = True
            Case Keys.F7
                TaskAdmin()
                e.Handled = True
            Case Keys.F8
                TaskProcess()
                e.Handled = True
            Case Keys.F9
                TaskReports()
                e.Handled = True

                ' ***** Insert Code Snippet #11 here

        End Select
    End Sub

    Private Sub ActLogin_Click(sender As Object, e As EventArgs) Handles ActLogin.Click
        ' ***** Insert Code Snippet #9 here.

    End Sub

    ' ***** Insert Code Snippet #10 here.

    ' ***** Insert Code Snippet #12 here.

End Class
