﻿' ----- The Library Project
'       Start-to-Finish Visual Basic 2015
'       Copyright (c) 2015 by Tim Patrick

Public Class ItemLimit
    Public Function PromptUser() As String
        ' ----- Prompt the user for search criteria.
        Me.ShowDialog()
        If (Me.DialogResult = DialogResult.OK) Then
            If (OptionAll.Checked = True) Then
                Return "*"
            Else
                Return ItemTitle.Text.Trim()
            End If
        Else
            Return ""
        End If
    End Function

    Private Sub ItemTitle_Enter(sender As Object, e As EventArgs) Handles ItemTitle.Enter
        ' ----- Highlight the entire text.
        ItemTitle.SelectAll()
    End Sub

    Private Sub ItemTitle_TextChanged(sender As Object, e As EventArgs) Handles ItemTitle.TextChanged
        ' ----- Make this a limited search.
        OptionByTitle.Checked = CBool(ItemTitle.Text.Trim().Length <> 0)
        OptionAll.Checked = Not OptionByTitle.Checked
    End Sub

    Private Sub ActOK_Click(sender As Object, e As EventArgs) Handles ActOK.Click
        ' ----- For name searches, require a value.
        If (OptionByTitle.Checked = True) And (ItemTitle.Text.Trim().Length = 0) Then
            MessageBox.Show("When searching by title, please supply a search text.",
                ProgramTitle, MessageBoxButtons.OK, MessageBoxIcon.Exclamation)
            Return
        End If
        Me.DialogResult = DialogResult.OK
    End Sub
End Class
