﻿' ----- The Library Project
'       Start-to-Finish Visual Basic 2015
'       Copyright (c) 2015 by Tim Patrick

Public Class CustomReport
    Private Sub CustomReport_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        ' ----- Link to the RDLC report design.
        Me.ReportViewer1.LocalReport.ReportEmbeddedResource =
            "SimpleReport.Report2.rdlc"

        ' ----- Create a fake table of fake records.
        Dim fakeSource As New Generic.List(Of FakeActivityRecord)

        ' ----- Add each of the fake records.
        fakeSource.Add(New FakeActivityRecord(1, "Breakfast"))
        fakeSource.Add(New FakeActivityRecord(2, "Lunch"))
        fakeSource.Add(New FakeActivityRecord(3, "Dinner"))

        ' ----- Build a new data source. Remember, it must have
        '       the same name.
        Dim fakeReportSource As New Microsoft.Reporting.WinForms.ReportDataSource
        fakeReportSource.Name = "SimpleReport_FakeActivityRecord"
        fakeReportSource.Value = fakeSource

        ' ----- Connect the data source to the report, and we're done.
        Me.ReportViewer1.LocalReport.DataSources.Add(fakeReportSource)
        Me.ReportViewer1.RefreshReport()
    End Sub
End Class
