﻿' ----- The Library Project
'       Start-to-Finish Visual Basic 2015
'       Copyright (c) 2015 by Tim Patrick

Public Class ListItemData
    Public ItemText As String
    Public ItemData As Long

    Public Sub New(displayText As String, itemID As Long)
        ' ----- Initialize the record.
        ItemText = displayText
        ItemData = itemID
    End Sub

    Public Overrides Function ToString() As String
        ' ----- Display the basic item text.
        Return ItemText
    End Function

    Public Overrides Function Equals(obj As Object) As Boolean
        ' ----- Allow IndexOf() and Contains() searches by ItemData.
        If (TypeOf obj Is Long) Then
            Return CBool(CLng(obj) = ItemData)
        Else
            Return MyBase.Equals(obj)
        End If
    End Function

    Public Shared Widening Operator CType(sourceItem As ListItemData) As Long
        ' ----- To convert to long, simply extract the numeric element.
        Return sourceItem.ItemData
    End Operator
End Class
