' ----- The Library Project
'       Start-to-Finish Visual Basic 2015
'       Copyright (c) 2015 by Tim Patrick

Public Class StandardReport
    Public Sub StartReport(ByVal whichMethod As String)
        If (whichMethod = "REAL") Then
            ' ----- Run the real report.
            Me.ActivityTableAdapter.Fill(Me.LibraryDataSet.Activity)
        Else
            ' ----- Run the custom report. Create a fake table
            '       of fake records.
            Dim fakeSource As New Generic.List(Of FakeActivityRecord)

            ' ----- Add each of the fake records.
            fakeSource.Add(New FakeActivityRecord(1, "Do some work"))
            fakeSource.Add(New FakeActivityRecord(2, "Take a nap"))
            fakeSource.Add(New FakeActivityRecord(3, "Write a program"))

            ' ----- The report was already bound to the true
            '       data source. Delete it.
            Me.ReportViewer1.LocalReport.DataSources.Clear()

            ' ----- Build a new data source. Remember, it must have
            '       the same name.
            Dim fakeReportSource As New Microsoft.Reporting.WinForms.ReportDataSource
            fakeReportSource.Name = "LibraryDataSet_Activity"
            fakeReportSource.Value = fakeSource

            ' ----- Connect the data source to the report, and we're done.
            Me.ReportViewer1.LocalReport.DataSources.Add(fakeReportSource)
        End If
        Me.Show()
    End Sub

    Private Sub StandardReport_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ' ----- Show the report.
        Me.ReportViewer1.RefreshReport()
    End Sub
End Class
